using PronunciationAssessment.Common;
using Newtonsoft.Json.Linq;
using System.Net.WebSockets;
using System.Text;
using Newtonsoft.Json;

namespace PronunciationAssessment

{
    class Program
    {
        const string API_KEY = "xxx";
        const string API_SECRET = "xxx";
        const string APP_ID = "xxx";
        const string HOST_URL = "ws://ise-api-sg.xf-yun.com/v2/ise";
        const string FILE = "D:\\static\\sdk\\tts_x4_EnUs_Gavin.pcm";
        const int FRAME_SIZE = 1280; //The audio size of each frame
        const int INTERVAL = 40; //Send audio interval(ms)
        const string CATEGORY = "read_sentence";
        const string SUB = "ise";
        const string ENT = "en";
        const string TEXT = "What's the weather like today";
        static async Task Main(string[] args)
        {
            Authentication.HttpMethod method = Authentication.HttpMethod.GET;
            Authentication authObj = new Authentication(API_KEY, API_SECRET);
            string authUrl = authObj.GenerateAuthUrl(HOST_URL, method);
            Console.WriteLine("authUrl---" + authUrl);

            var client = new ClientWebSocket();
            await client.ConnectAsync(new Uri(authUrl), CancellationToken.None);

            string message = GenerateDataSsb();
            var buffer = Encoding.UTF8.GetBytes(message);
            var sendBuffer = new ArraySegment<byte>(buffer);
            await client.SendAsync(sendBuffer, WebSocketMessageType.Text, true, CancellationToken.None);


            // readerBuffer
            BinaryReader br = new BinaryReader(new FileStream(FILE, FileMode.Open));
            byte[] currentFrame = br.ReadBytes(FRAME_SIZE);
            bool moreData = true;

            string message0 = GenerateDataSend(1, 1, currentFrame);
            var buffer0 = Encoding.UTF8.GetBytes(message0);
            var sendBuffer0 = new ArraySegment<byte>(buffer0);
            await client.SendAsync(sendBuffer0, WebSocketMessageType.Text, true, CancellationToken.None);
            while (moreData)
            {
                currentFrame = br.ReadBytes(FRAME_SIZE);
                if (currentFrame.Length != 0)
                {
                    string message1 = GenerateDataSend(2, 1, currentFrame);
                    var buffer1 = Encoding.UTF8.GetBytes(message1);
                    var sendBuffer1 = new ArraySegment<byte>(buffer1);
                    await client.SendAsync(sendBuffer1, WebSocketMessageType.Text, true, CancellationToken.None);
                }
                else
                {
                    moreData = false;
                    string message2 = GenerateDataSend(4, 2, new byte[0]);
                    var buffer2 = Encoding.UTF8.GetBytes(message2);
                    var sendBuffer2 = new ArraySegment<byte>(buffer2);
                    await client.SendAsync(sendBuffer2, WebSocketMessageType.Text, true, CancellationToken.None);
                }

            }

            br.Close();
            Console.WriteLine($"Sent: {message}");



            while (true)
            {
                // onMessage
                var receivebuffer = new ArraySegment<byte>(new byte[10240]);
                var result = await client.ReceiveAsync(receivebuffer, CancellationToken.None);
                string serverMessage = Encoding.UTF8.GetString(receivebuffer.Array, 0, result.Count);
                Console.WriteLine($"Server message: {serverMessage}");

                var state = client.State;
                Console.WriteLine($"state: {state}");

                if (state == WebSocketState.CloseReceived)
                {
                    Console.WriteLine("onClose---");
                    await Task.Delay(5000);
                    await client.CloseAsync(WebSocketCloseStatus.NormalClosure, "Closing", CancellationToken.None);
                    break;
                }

            }

        }

        private static string GenerateDataSsb()
        {
            var p = new Dictionary<string, object>();
            p.Add("common", new Dictionary<string, object>
{
    { "app_id", APP_ID }
});
            p.Add("business", new Dictionary<string, object>
{
    { "category", CATEGORY },
     { "ent", ENT },
     { "cmd", "ssb" },
    { "ssm", "1" },
    { "auf", "audio/L16;rate=16000" },
    { "aue", "raw" },
    // Review Text (new String(new byte[] { (byte) 0xEF, (byte) 0xBB, (byte) 0xBF })+text)
    { "text",  TEXT } //Base64.getEncoder().encodeToString(text.getBytes())
});
            p.Add("data", new Dictionary<string, object>
{
    { "status", 0 },
    { "data", "" }
});
            return JsonConvert.SerializeObject(p);
        }

        private static string GenerateDataSend(int aus, int statusint, byte[] data)
        {
            Thread.Sleep(INTERVAL);
            var p = new Dictionary<string, object>
{
    { "business", new Dictionary<string, object>
        {
            { "cmd", "auw" },
            { "aus", aus },
            { "aue", "raw" }
        }
    },
    { "data", new Dictionary<string, object>
        {
            { "status", statusint },
            { "data", Convert.ToBase64String(data) },
            { "data_type", 1 },
            { "encoding", "raw" }
        }
    }
};
            return JsonConvert.SerializeObject(p);
        }

    }
}